/*	NETMON netmonstat.c  (MITRE)	    12/18/88	*/


/*
 * netmonstat.c: utility for checking up on NETMON operation.
 * By: A. Mankin
 *
 *
 * Copyright (c) 1989, the MITRE Corporation.  All rights reserved.
 * This software was developed by the MITRE Corporation, McLean VA.
 * It is distributed free of charge with the following conditions:
 *
 *      1.  Redistribution and use in source and binary forms are permitted
 *	    provided that this copyright notice be duplicated in all such
 *	    forms.
 *
 *      2.  MITRE will be credited should the software be used in a
 *          product or written about in any publications.  However,
 *          MITRE will not be referenced as the source in advertisements.
 *
 *      3.  MITRE assumes no legal responsibility for source code and
 *          its subsequent use.  No warranty is expressed or implied.
 *
 *      4.  If any bugs or problems are found, then they should be
 *          reported back to MITRE.
 */

#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <nlist.h>

#define NETMON_KERNEL
#include <net/netmon.h>

struct netmonstat nmts;

struct netmoncb {
     short currbuf;
     short readwait;
     short readminoff;
     short sigminoff;
     u_long drops;
} nc;

struct netmonbuf {
     short rw;
     short off;
     struct netmonstr recs[NM_MAXTRACED >> 1];
} nb;

struct nlist unl[] = {
  {"_netmonstat"},
  {"_netmoncb"},
  {"_netmonbuf"},
  {0}
};

int verbose = 1;

main()
{
	init_for_kmem(unl); 
	klookup(unl[0].n_value, &nmts, sizeof(nmts));
	printf("\trecords\tsleeps\twakes\trflips\tfflips\tdrops\n");
	printf("\t%d\t%d\t%d\t%d\t%d\t%d\n",
		nmts.records,
		nmts.readsleeps,
		nmts.readwakes,
		nmts.readbufferflips,
		nmts.fullbufferflips,
		nmts.fullbufferdrops);
	klookup(unl[1].n_value, &nc, sizeof(nc));
	printf("\tcurrbuf\twflg\tminread\n");
	printf("\t%d\t%d\t%d\n",
	        nc.currbuf,
		nc.readwait,
		nc.readminoff);
	klookup(unl[2].n_value, &nb, sizeof(nb));
	printf("netmonbuf 0 rw %d off %d\n", nb.rw, nb.off);
        klookup(unl[2].n_value + sizeof(nb), &nb, sizeof(nb));
	printf("netmonbuf 1 rw %d off %d\n", nb.rw, nb.off);
	

}


